/*------------------------------------------------------------------------------------------------*/
/*                                        Fonctions diverses                                      */
/*------------------------------------------------------------------------------------------------*/

#include "header.h"



/*------------------------------------------------------------------------------------------------*/
/*                  Fonction permettant de dtecter le type du caractre                          */
/*------------------------------------------------------------------------------------------------*/
/* Renvoit : */
/* 0 si le caractre est non reconnu */
/* 1 si le caractre est un sparateur (espace, point virgule et retour chariot) */
/* 2 si le caractre est alphabtique ou est un underscore */
/* 3 si le caractre est un nombre */
/* 4 si le caractre est un regroupeur (parenthses et guillemets) */
/* 5 si le caractre est un oprateur logique (gal, infrieur, suprieur) */

int typeChar(char c) {

if ( isspace(c) != 0 ) return 1;
if ( c == '	' ) return 1;
if ( c == ';' ) return 1;

if ( isalpha(c) != 0 ) return 2;
if ( c == '_' ) return 2;

if ( isdigit(c) != 0 ) return 3;

if ( c == '(' ) return 4;
if ( c == ')' ) return 4;
if ( c == '"' ) return 4;

if ( c == '=' ) return 5;
if ( c == '<' ) return 5;
if ( c == '>' ) return 5;

return 0;

}





/*------------------------------------------------------------------------------------------------*/
/*              Fonction permettant de dtecter le plus petit de deux entiers                     */
/*------------------------------------------------------------------------------------------------*/

int mini(int k, int l) {

if ( k < l ) return k;
return l;

}




/*------------------------------------------------------------------------------------------------*/
/*              Fonction permettant de dtecter le plus grand de deux entiers                     */
/*------------------------------------------------------------------------------------------------*/

int maxi(int k, int l) {

if ( k > l ) return k;
return l;

}




/*------------------------------------------------------------------------------*/
/*  Fonction convertissant les entiers (jusque 999999) en chanes de caractres */
/*------------------------------------------------------------------------------*/

void int2str(char *c, int n) {

char cInt[7];
int test=0, k=0, nb;

if ( n == 0 ) {
     *(c+0) = '0';
     for ( k = 1; k < 7; k++ ) *(c+k) = '\0';
}
else {
     nb = n;
     while ( test == 0 ) {
           if ( nb == 0 ) test = 1;
           if ( k > 6 ) test = 1;
           if ( test == 0 ) {
                cInt[k] = char(48+(nb%10));
                nb = nb - nb%10;
                nb = nb/10;
                k++;
           }
     }

     for ( test = 0; test < k; test++ ) {
         *(c+test) = cInt[k-test-1];
     }
     for ( test = k; test < 7; test++ ) {
         *(c+test) = '\0';
     }
}

}






// Dtection du "ou exclusif" sur des variables externes/autres objets
int XorExt(INFO inf, INFO inf2) {

int var, var2;

if ( ( inf.typeInf >= 25 ) && ( inf.typeInf <= 29 ) ) var = 1;
else var = 0;

if ( ( inf2.typeInf >= 25 ) && ( inf2.typeInf <= 29 ) ) var2 = 1;
else var2 = 0;

var = var + var2;

if ( var == 1 ) return 1;

return 0;

}






void synDetectBadTab(char ligne[5000], int nLigne) {
     
     
FILE *fInf, *fErr;
int k, l, m, mem, test=0, compteur, check=0, var, trouve=0;
char IDobjet[5000], IDobjet2[50], nbItem[7], cInt[7];
ERREUR err;
INFO inf;

for ( k = 0; k < strlen(ligne); k++ ) {
    if ( isalpha(ligne[k]) != 0 ) ligne[k] = tolower(ligne[k]);
}

k=0;
while ( ( ( ligne[k] == ' ' ) || ( ligne[k] == '\t' ) ) && ( k < strlen(ligne) ) ) k++;

compteur = 0;
while ( k < strlen(ligne) ) {
      if ( ligne[k] == '\t' ) compteur++;
      k++;
}

if ( compteur > 0 ) {
     fErr = fopen("DbTempTES3", "ab");
     if ( fErr == NULL ) {
          printf("Impossible d'ouvrir le fichier \"DbTempTES3\" depuis le fichier source \"typeScript.cpp\".\n\n");
          system("PAUSE");
          exit(1);
     }
     err.ligneErr = nLigne;
     err.niveau = 1;
     strcpy(err.messageErr, "    - Ligne ");
     int2str(&(cInt[0]), nLigne+1);
     strcat(err.messageErr, cInt);
     strcat(err.messageErr, " : alerte, ");
     int2str(&(cInt[0]), compteur);
     strcat(err.messageErr, cInt);
     strcat(err.messageErr, " tabulation");
     if ( compteur > 1 ) strcat(err.messageErr, "s ont t detectes");
     else strcat(err.messageErr, " a t detecte");
     strcat(err.messageErr, " aprs le premier caractre (risques de plantage in-game).");
     fwrite(&err, sizeof(ERREUR), 1, fErr);
     trouve = 1;
     fclose(fErr);
}

}






void synDetectUnderscore() {

FILE *fErr, *fInf;
INFO inf;
ERREUR err;

fErr = fopen("DbTempTES3", "ab");
if ( fErr == NULL ) {
     printf("Impossible d'ouvrir le fichier temporaire \"DbTempTES3\" depuis le fichier source \"MainSyntaxe.cpp\"\n\n");
     system("PAUSE");
     exit(1);
}

fInf = fopen("InfTempTES3", "rb");
if ( fInf == NULL ) {
   printf("Impossible d'ouvrir le fichier \"InfTempTES3\" depuis le fichier source \"MainTriInfo.cpp\".\n\n");
   system("PAUSE");
   fclose(fErr);
   exit(1);
}

while ( fread(&inf, sizeof(INFO), 1, fInf) != 0 ) {
      if ( (inf.Nom)[0] == '_' ) {
           err.ligneErr = -1;
           err.niveau = 1;
           strcpy(err.messageErr, "    - Le premier caractre de \"");
           strcat(err.messageErr, inf.Nom);
           strcat(err.messageErr, "\" est un underscore, risques de bugs in-game.");
           fwrite(&err, sizeof(ERREUR), 1, fErr);
      }
}

fclose(fErr);
fclose(fInf);

}






int IsLocal(char Str[50]) {
     
FILE *fInf;
INFO inf2;
ERREUR err;
int compteur, test, k, l;
  
fInf = fopen("InfTempTES3", "rb");
if ( fInf == NULL ) {
   printf("Impossible d'ouvrir le fichier \"InfTempTES3\" depuis le fichier source \"MainTriInfo.cpp\".\n\n");
   system("PAUSE");
   exit(1);
}

test = 0;
while ( ( test == 0 ) && ( fread(&inf2, sizeof(INFO), 1, fInf) != 0 ) ) {
      for ( k = 0; k < strlen(inf2.Nom); k++ ) {
          if ( isalpha(inf2.Nom[k]) != 0 ) inf2.Nom[k] = tolower(inf2.Nom[k]);
      }
      if ( strncmp(Str, inf2.Nom, maxi(strlen(Str), strlen(inf2.Nom))) == 0 ) {
           if ( ( inf2.typeInf >= 0 ) && ( inf2.typeInf < 5 ) ) {
                fclose(fInf);
                return 1;
           }
           else {
                fclose(fInf);
                return 0;
           }
      }
}

fclose(fInf);
return -1;

}
